#!/bin/bash
set -e

DOCKER_DIR="$(dirname $(realpath $0))"

if docker ps >/dev/null 2>/dev/null; then
    DOCKER="docker"
elif sudo docker ps >/dev/null 2>/dev/null; then
    DOCKER="sudo docker"
else
    echo "Docker not found. Please install: https://docs.docker.com/engine/installation/";
    exit;
fi

DKRIMG="$(basename $(dirname $(dirname $(realpath $0))))"
echo image: $DKRIMG

$DOCKER login git.digitalstrom.org:4567
$DOCKER pull git.digitalstrom.org:4567/dss/dss-mainline/base:latest

USER=`id -un`
DOCKERFILE=Dockerfile
if [ -f $DOCKER_DIR/Dockerfile.${USER} ]; then
    DOCKERFILE=Dockerfile.${USER}
fi

$DOCKER build -t $DKRIMG \
    -f $DOCKER_DIR/$DOCKERFILE \
    --build-arg gid=`id -g` \
    --build-arg group=`id -gn` \
    --build-arg uid=`id -u` \
    --build-arg user=`id -un` \
    $DOCKER_DIR
