/*
    Copyright (c) 2018 digitalSTROM AG, Zurich, Switzerland

    This file is part of dSS.

    vdSM is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 2 of the License.

    vdSM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with dSS. If not, see <http://www.gnu.org/licenses/>.
*/

#include "cache-db.h"

namespace dss {

ds::LogChannel cacheDbLogChannel("CacheDb");

std::vector<Dsuid> CacheDbBase::devices() const {
  std::lock_guard<std::mutex> lock(m_mutex);
  auto result = std::vector<Dsuid>{};
  auto statement = m_db->exec("select dsuid from " + m_tableName);
  for (auto&& row : statement.rows<std::string>()) {
    result.emplace_back(Dsuid(std::get<0>(row)));
  }
  return result;
}
}
