#pragma once

#include <ds-api/event.h>
#include <ds-api/rest.h>
#include <ds/clock.h>
#include <ds/enum.h>
#include <ds/reflect.h>
#include <ds/str.h>

#include <boost/serialization/strong_typedef.hpp>
#include <memory>
#include <string>
#include <vector>

#include "apartment.h"
#include "api-revision.h"
#include "applications.h"
#include "common.h"
#include "devices.h"
#include "groups.h"
#include "installation.h"
#include "meterings.h"
#include "model-fwd.h"
#include "model-ids.h"
#include "scenarios.h"
#include "user-defined-states.h"

///
/// Ds-model.
///
/// Reference documentation:
/// https://git.digitalstrom.org/digitalstrom-documentation/public-api-documentation/tree/master/apis/apartment
///

DS_REFLECTED_ENUM((dsModel), PowerKind, (none)(consumed)(produced)(selfConsumed));

namespace dsModel {

extern const dsApi::EventType apartmentStructureChanged;

struct GroupStatus {
  std::string id{};
  // TODO(someday): refactor to std::variant<LightsStatus, ShadesStatus, AwningsStatus, AudioStatus, ...>
  ZoneApplicationsStatus application{}; // Only one application shall be set.
};

extern const dsApi::EventType apartmentStatusChanged;

extern const dsApi::EventType meteringValues;


} // namespace dsModel

DS_JSON_DECLARE_STRUCT((dsModel), GroupStatus, (id)(application));
