// Generated file.  DO NOT EDIT!
// source: scenarios.yaml

// clang-format off

#pragma once


/// Scenarios
///
/// Scenarios, signals, etc

#include "scenarios-fwd.h"
#include <ds/enum.h>
#include <ds/clock.h>

#include "common-fwd.h"
#include "devices-fwd.h"
#include "groups-fwd.h"
#include "common.h"
#include "model-fwd.h"

#include <ds/json.h>

DS_REFLECTED_ENUM((dsModel), CommonActionId,
    (none)
    (preset0)
    (preset1)
    (preset2)
    (preset3)
    (preset4)
    (preset10)
    (preset11)
    (preset12)
    (preset13)
    (preset14)
    (preset20)
    (preset21)
    (preset22)
    (preset23)
    (preset24)
    (preset30)
    (preset31)
    (preset32)
    (preset33)
    (preset34)
    (preset40)
    (preset41)
    (preset42)
    (preset43)
    (preset44)
);

DS_REFLECTED_ENUM((dsModel), ScenarioStatusStatus,
    (none)
    (active)
    (inactive)
    (undefined)
);

DS_REFLECTED_ENUM((dsModel), InvokeScenariosArgsContext,
    (none)
    (applicationZone)
    (applicationApartment)
    (applicationGroup)
    (applicationArea)
    (applicationSingleDevice)
    (deviceStandard)
    (deviceDynamic)
    (deviceCustom)
    (userDefinedAction)
);

DS_REFLECTED_ENUM((dsModel), ApartmentActionType,
    (none)
    (absent)
    (present)
    (sleeping)
    (wakeup)
    (doorBell)
    (panic)
    (panicEnd)
    (fire)
    (fireEnd)
    (fireMute)
    (alarm1)
    (alarm1End)
    (alarm2)
    (alarm2End)
    (alarm3)
    (alarm3End)
    (alarm4)
    (alarm4End)
    (smoke)
    (smokeEnd)
    (water)
    (waterEnd)
    (gas)
    (gasEnd)
    (wind)
    (windEnd)
    (rain)
    (rainEnd)
    (hail)
    (hailEnd)
    (frost)
    (frostEnd)
    (pollution)
    (pollutionEnd)
);

DS_REFLECTED_ENUM((dsModel), LightsActionType,
    (none)
    (off)
    (on)
    (brighter)
    (darker)
    (stop)
    (forcedOff)
    (fadeOff)
);

namespace dsModel {
struct DeviceScenarioAttributes {
  Translatable name{};
  DSDeviceId dsDevice{};
  DeviceScenarioActionId actionId{};

  ~DeviceScenarioAttributes();
};

struct DeviceScenario {
  DeviceScenarioId id{};
  std::string type = "deviceScenario";
  ds::DateTime lastChanged{};
  DeviceScenarioAttributes attributes{};

  ~DeviceScenario();
};

struct ApplicationZoneScenarioAttributes {
  std::string name{};
  CommonActionId actionId{};

  /// deprecated in favour of `type`. Set to `applicationZone` for backwards compatibility
  std::string context{};
  std::vector<SubmoduleId> submodules{};
  std::vector<DSDeviceId> dsDevices{};
  ZoneId zone{};
  ZoneApplicationType application{};

  ~ApplicationZoneScenarioAttributes();
};

struct ApplicationZoneScenario {
  ApplicationZoneScenarioId id{};
  std::string type = "applicationZoneScenario";
  ds::DateTime lastChanged{};
  ApplicationZoneScenarioAttributes attributes{};

  ~ApplicationZoneScenario();
};

struct ScenarioStatus {
  ScenarioId id{};
  ScenarioStatusStatus status{};

  /// Process completed in percent, if available
  std::optional<double> completed{};

  /// Planned time for activation, if available
  ds::DateTime scheduledAt{};

  /// End time of process, if available
  ds::DateTime terminatesAt{};

  ~ScenarioStatus();
};

struct UserDefinedActionAttributes {
  std::string name{};

  ~UserDefinedActionAttributes();
};

struct UserDefinedAction {
  UserDefinedActionId id{};
  std::string type = "userDefinedAction";
  ds::DateTime lastChanged{};
  UserDefinedActionAttributes attributes{};

  ~UserDefinedAction();
};

using Scenario = std::variant<std::monostate, ApplicationZoneScenario, DeviceScenario, UserDefinedAction>;


/// Description of the scenario to be executed. The *context* parameter is
/// required, the others are optional and depend on context.
///
/// See https://confluence.digitalstrom.org/display/SA/Standard+Scenarios
struct InvokeScenariosArgs {
  InvokeScenariosArgsContext context{};

  /// Example: on
  std::string actionId{};

  /// Example: lights
  std::string application{};

  /// area number
  ///
  /// Example: 4
  std::string area{};

  /// zone id
  ///
  /// Example: 12345
  std::string zone{};

  /// Example: 3504175fe0000000000000000000515f00
  std::string dsDevice{};

  ~InvokeScenariosArgs();
};

struct Scenarios {
  std::vector<Scenario> scenarios{};

  ~Scenarios();
};

struct ApartmentAction {

  /// Apartment action can target apartment, zone, dsDevice
  std::string type = "apartment";
  ApartmentActionType id{};

  ~ApartmentAction();
};

struct LightsAction {

  /// Lights action can target lights in apartment, lights in zone, lights in dsDevice, lights submodule
  std::string type = "lights";
  LightsActionType id{};

  ~LightsAction();
};

using Action = std::variant<std::monostate, ApartmentAction, LightsAction>;

struct SignalTargetApartment {

  /// Apartment action can target apartment, zone, dsDevice
  std::string type = "apartment";

  ~SignalTargetApartment();
};

using SignalTarget = std::variant<std::monostate, SignalTargetApartment>;

struct SignalAttributes {
  SignalTarget target{};
  Action action{};

  ~SignalAttributes();
};

struct Signal {
  SignalId id{};
  std::string type = "signal";
  ds::DateTime lastChanged{};
  SignalAttributes attributes{};

  ~Signal();
};

} // namespace dsModel

DS_JSON_DECLARE_STRUCT((dsModel), DeviceScenarioAttributes,
    (name)
    (dsDevice)
    (actionId)
);
DS_JSON_DECLARE_STRUCT((dsModel), DeviceScenario,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApplicationZoneScenarioAttributes,
    (name)
    (actionId)
    (context)
    (submodules)
    (dsDevices)
    (zone)
    (application)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApplicationZoneScenario,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), ScenarioStatus,
    (id)
    (status)
    (completed)
    (scheduledAt)
    (terminatesAt)
);
DS_JSON_DECLARE_STRUCT((dsModel), UserDefinedActionAttributes,
    (name)
);
DS_JSON_DECLARE_STRUCT((dsModel), UserDefinedAction,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
template <>
struct DSJsonVariantTrait<dsModel::Scenario> {
  static constexpr auto discriminator = "type";
  static constexpr auto nameVisitor = ::ds::Visitor{
      [](const std::monostate &) { return ""; },
      [](const dsModel::ApplicationZoneScenario &) { return "applicationZoneScenario"; },
      [](const dsModel::DeviceScenario &) { return "deviceScenario"; },
      [](const dsModel::UserDefinedAction &) { return "userDefinedAction"; },
  };
};
DS_JSON_DECLARE((dsModel), Scenario);

DS_JSON_DECLARE_STRUCT((dsModel), InvokeScenariosArgs,
    (context)
    (actionId)
    (application)
    (area)
    (zone)
    (dsDevice)
);
DS_JSON_DECLARE_STRUCT((dsModel), Scenarios,
    (scenarios)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentAction,
    (type)
    (id)
);
DS_JSON_DECLARE_STRUCT((dsModel), LightsAction,
    (type)
    (id)
);
template <>
struct DSJsonVariantTrait<dsModel::Action> {
  static constexpr auto discriminator = "type";
  static constexpr auto nameVisitor = ::ds::Visitor{
      [](const std::monostate &) { return ""; },
      [](const dsModel::ApartmentAction &) { return "apartment"; },
      [](const dsModel::LightsAction &) { return "lights"; },
  };
};
DS_JSON_DECLARE((dsModel), Action);

DS_JSON_DECLARE_STRUCT((dsModel), SignalTargetApartment,
    (type)
);
template <>
struct DSJsonVariantTrait<dsModel::SignalTarget> {
  static constexpr auto discriminator = "type";
  static constexpr auto nameVisitor = ::ds::Visitor{
      [](const std::monostate &) { return ""; },
      [](const dsModel::SignalTargetApartment &) { return "apartment"; },
  };
};
DS_JSON_DECLARE((dsModel), SignalTarget);

DS_JSON_DECLARE_STRUCT((dsModel), SignalAttributes,
    (target)
    (action)
);
DS_JSON_DECLARE_STRUCT((dsModel), Signal,
    (id)
    (type)
    (lastChanged)
    (attributes)
);

