#pragma once

#include <boost/locale/localization_backend.hpp>

namespace ds {
namespace locale {

/// Boost locale localization backend manager initializing
/// locale generators to use with dsLocale.
///
/// `boost::locale::generator` is  not copy-able nor move-able.
/// So we must expose `localization_backend_manager`
/// that initializes `boost::locale::generator` instances.
///
const boost::locale::localization_backend_manager& backend();

} // locale
} // ds
