
/*
 This file is part of the digitalSTROM dsm-api library.

 Copyright (C) 2010-2018 digitalSTROM.org, Schlieren, Switzerland

 digitalSTROM dsm-api library is free software: you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 digitalSTROM dsm-api library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with digitalSTROM dsm-api library. If not, see <http://www.gnu.org/licenses/>.
 
 NOTE: The dsm-api library and it's script bindings are unsupported interfaces and
 subject to change without further notice.
 
 */
 /*
 * DO NOT MANUALLY MODIFY! 
 *
 * THIS FILE IS AUTOGENERATED FROM THE dSM-API XML DEFINITIONS IN
 * dsm-api.xml.
 * Make any changes in the XML definition and regenerate this file.
 */
/**
 * @file dsm-api-mock.h
 *
 * This is the dSM-API-mock declaration.
 */

#pragma once

#include <trompeloeil.hpp>

#include <digitalSTROM/dsm-api-v2/dsm-api.h>

class DsmApi {
public:
MAKE_MOCK0(DsmApiLibraryVersion, int(void));
MAKE_MOCK0(DsmApiInitialize, DsmApiHandle_t(void));
MAKE_MOCK3(DsmApiOpen, int(DsmApiHandle_t, const char *, int));
MAKE_MOCK2(DsmApiGetOwnDSUID, int(DsmApiHandle_t, dsuid_t *));
MAKE_MOCK3(DsmApiGetBusMembers, int(DsmApiHandle_t, dsuid_t *, int));
MAKE_MOCK4(DsmApiGetBusMembersPerType, int(DsmApiHandle_t, dsuid_t *, int, unsigned int));
MAKE_MOCK2(DsmApiGetLinkState, int(DsmApiHandle_t, bool *));
MAKE_MOCK1(DsmApiRestartBus, int(DsmApiHandle_t));
MAKE_MOCK1(DsmApiClose, int(DsmApiHandle_t));
MAKE_MOCK1(DsmApiCleanup, int(DsmApiHandle_t));

MAKE_MOCK6(DsmApiSetCallback, int(DsmApiHandle_t, container_type_t, uint8_t, uint8_t, DsmApiCallback_t *const, DsmApiCallback_t *));
MAKE_MOCK3(DsmApiSetLinkStateCallback, int(DsmApiHandle_t, DsmApiCallback_t *const, DsmApiCallback_t *));
MAKE_MOCK3(DsmApiSetBusChangeCallback, int(DsmApiHandle_t, DsmApiCallback_t *const, DsmApiCallback_t *));
MAKE_MOCK3(DsmApiSetBlockingCallback, int(DsmApiHandle_t, DsmApiCallback_t *const, DsmApiCallback_t *));

MAKE_MOCK6(DsmApiGetDeviceDSUID, int(uint16_t, uint16_t, uint8_t, uint16_t, uint32_t, dsuid_t *));
MAKE_MOCK2(DsmApiGetEthernetDSUID, int(const char *, dsuid_t *));
MAKE_MOCK3(DsmApiGetEthernetInfo, int(const char *, const char **, const char **));
MAKE_MOCK7(DsmApiGetDeviceDescription,
           int(uint16_t, uint16_t, uint8_t, uint16_t, const char **, const char **, const char **));
MAKE_MOCK1(DsmApiIsdSM, int(dsuid_t));

MAKE_MOCK6(DeviceStatisticsRequest_get_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, int, uint16_t *));
MAKE_MOCK7(DeviceConfig_get_sync_8, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t, int, uint8_t *));
MAKE_MOCK7(DeviceConfig_get_sync_16, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t, int, uint16_t *));
MAKE_MOCK7(DeviceConfig_set_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t, uint8_t, int));
MAKE_MOCK5(DeviceProperties_set_zone_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t, int));
MAKE_MOCK5(DeviceProperties_set_button_set_output_channel_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, int));
MAKE_MOCK5(DeviceProperties_set_button_active_group_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, int));
MAKE_MOCK5(DeviceGroupMembershipModify_add_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, int));
MAKE_MOCK6(DeviceOPCConfig_get_current_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, int, uint16_t *));
MAKE_MOCK7(DeviceOPCConfig_get_scene_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t, int, uint16_t *));
MAKE_MOCK6(DeviceOPCConfig_get_scene_config_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, int, uint16_t *));
MAKE_MOCK6(DeviceOPCConfig_get_dc_flags_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, int, uint16_t *));
MAKE_MOCK6(TestTransmissionQuality_get_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, int, uint8_t *, uint16_t *));
MAKE_MOCK6(DeviceSensor_get_value_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, int, uint16_t *));
MAKE_MOCK9(DeviceSensor_get_value_extended_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, int, double *, uint32_t *, uint32_t *, uint8_t *));
MAKE_MOCK6(DeviceDslinkSend_not_last_byte_with_answer_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, int, uint8_t *));
MAKE_MOCK6(DeviceDslinkSend_last_byte_with_answer_sync, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, int, uint8_t *));
MAKE_MOCK15(ClusterInfo_by_id, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t *, uint8_t *, uint16_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint16_t *, uint16_t *, uint16_t *, uint32_t *));
MAKE_MOCK4(ClusterProperties_set_name, int(DsmApiHandle_t, dsuid_t, uint8_t, const uint8_t *));
MAKE_MOCK4(ClusterProperties_set_stop_timeout, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t));
MAKE_MOCK4(ClusterProperties_set_state_machine, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t));
MAKE_MOCK6(ClusterProperties_set_location_class, int(DsmApiHandle_t, dsuid_t, uint8_t, uint16_t, uint16_t, uint16_t));
MAKE_MOCK4(ClusterProperties_set_configuration_lock, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t));
MAKE_MOCK4(ClusterProperties_set_scene_lock, int(DsmApiHandle_t, dsuid_t, uint8_t, const uint8_t *));
MAKE_MOCK4(ClusterProperties_get_operation_lock, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t *));
MAKE_MOCK5(ClusterProperties_set_application, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t, uint32_t));
MAKE_MOCK4(ClusterProperties_get_state, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t *));
MAKE_MOCK4(ClusterProperties_set_state, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t));

MAKE_MOCK5(EventGeneric, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, const uint8_t *));

MAKE_MOCK3(ZoneCount, int(DsmApiHandle_t, dsuid_t, uint8_t *));
MAKE_MOCK7(ZoneInfo_by_index, int(DsmApiHandle_t, dsuid_t, uint8_t, uint16_t *, uint8_t *, uint8_t *, uint8_t *));
MAKE_MOCK7(ZoneInfo_by_id, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t *, uint8_t *, uint8_t *, uint8_t *));
MAKE_MOCK3(ZoneModify_add, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK3(ZoneModify_remove, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK4(ZoneModify_change_id, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t));
MAKE_MOCK4(ZoneDeviceCount_only_active, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t *));
MAKE_MOCK4(ZoneDeviceCount_only_inactive, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t *));
MAKE_MOCK4(ZoneDeviceCount_all, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t *));
MAKE_MOCK4(ZoneProperties_set_name, int(DsmApiHandle_t, dsuid_t, uint16_t, const uint8_t *));
MAKE_MOCK18(ZoneProperties_get_scene_history, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *));
MAKE_MOCK8(ZoneProperties_get_room_states, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *));
MAKE_MOCK5(ZoneProperties_set_zone_sensor, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, dsuid_t));
MAKE_MOCK5(ZoneProperties_get_zone_sensor, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, dsuid_t *));
MAKE_MOCK4(ZoneProperties_reset_zone_sensor, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK6(ZoneProperties_get_zone_sensor_value, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t *, uint32_t *));

MAKE_MOCK5(ZoneGroupModify_add, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t));
MAKE_MOCK4(ZoneGroupModify_remove, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK11(ZoneGroupInfo_by_index, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t *, uint8_t *, uint16_t *, uint8_t *, uint8_t *, uint8_t *, uint32_t *));
MAKE_MOCK11(ZoneGroupInfo_by_id, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t *, uint8_t *, uint16_t *, uint8_t *, uint8_t *, uint8_t *, uint32_t *));
MAKE_MOCK5(ZoneGroupProperties_set_name, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, const uint8_t *));
MAKE_MOCK5(ZoneGroupProperties_set_stop_timeout, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t));
MAKE_MOCK5(ZoneGroupProperties_set_state_machine, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t));
MAKE_MOCK6(ZoneGroupProperties_set_application, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t, uint32_t));
MAKE_MOCK14(ZoneGroupProperties_get_scene_history, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *));
MAKE_MOCK9(ZoneGroupProperties_set_state, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t, uint8_t, uint8_t, uint8_t, uint8_t));

MAKE_MOCK18(ControllerHeating_set_config, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t, uint8_t, uint16_t, uint16_t, uint16_t, uint16_t, uint8_t, uint8_t, uint8_t, uint8_t, uint16_t, uint16_t, uint8_t, uint8_t));
MAKE_MOCK18(ControllerHeating_get_config, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t *, uint16_t *, uint8_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint16_t *, uint16_t *, uint8_t *, uint8_t *));
MAKE_MOCK13(ControllerHeating_get_internals, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint32_t *, uint32_t *, uint32_t *, uint32_t *, uint8_t *, uint8_t *));
MAKE_MOCK19(ControllerHeating_set_operation_modes, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t, uint16_t, uint16_t, uint16_t, uint16_t, uint16_t, uint16_t, uint16_t, uint16_t, uint16_t, uint16_t, uint16_t, uint16_t, uint16_t, uint16_t, uint16_t));
MAKE_MOCK19(ControllerHeating_get_operation_modes, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *));
MAKE_MOCK4(ControllerHeating_set_state, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(ControllerHeating_get_state, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t *));

MAKE_MOCK6(ZoneGroupSceneInfo, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t, uint8_t *));
MAKE_MOCK6(ZoneGroupSceneProperties_set_name, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t, const uint8_t *));
MAKE_MOCK6(ZoneGroupActionRequest_action_call_scene, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t, uint8_t));
MAKE_MOCK6(ZoneGroupActionRequest_action_save_scene, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t, uint8_t));
MAKE_MOCK5(ZoneGroupActionRequest_action_undo_scene, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t));
MAKE_MOCK5(ZoneGroupActionRequest_action_blink, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t));
MAKE_MOCK6(ZoneGroupActionRequest_action_undo_scene_number, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t, uint8_t));
MAKE_MOCK6(ZoneGroupActionRequest_action_force_call_scene, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t, uint8_t));
MAKE_MOCK6(ZoneGroupActionRequest_action_set_outval, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t, uint8_t));
MAKE_MOCK6(ZoneGroupActionRequest_action_set_scene_local_priority, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t, uint8_t));
MAKE_MOCK5(ZoneGroupActionRequest_action_programming_mode_on, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t));
MAKE_MOCK5(ZoneGroupActionRequest_action_programming_mode_off, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t));
MAKE_MOCK5(ZoneGroupActionRequest_action_select_group, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t));
MAKE_MOCK6(ZoneGroupActionRequest_action_register_scene_local_priority, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t, uint8_t));
MAKE_MOCK6(ZoneGroupActionRequest_action_call_scene_min, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t, uint8_t));
MAKE_MOCK5(ZoneGroupActionRequest_action_local_stop, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t));
MAKE_MOCK6(ZoneGroupActionRequest_action_opc_inc, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t, uint8_t));
MAKE_MOCK6(ZoneGroupActionRequest_action_opc_dec, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t, uint8_t));
MAKE_MOCK6(ZoneGroupActionRequest_action_opc_stop, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t, uint8_t));
MAKE_MOCK6(ZoneGroupActionRequest_action_extra_command, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t, uint8_t));
MAKE_MOCK5(ZoneGroupActionRequest_action_fire_mute, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t));
MAKE_MOCK8(ZoneGroupSensorPush, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, dsuid_t, uint8_t, uint16_t, uint8_t));

MAKE_MOCK19(DeviceInfo_by_index_only_active, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, dsuid_t *, uint8_t *, uint8_t *));
MAKE_MOCK19(DeviceInfo_by_index_only_inactive, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, dsuid_t *, uint8_t *, uint8_t *));
MAKE_MOCK19(DeviceInfo_by_index, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, dsuid_t *, uint8_t *, uint8_t *));
MAKE_MOCK18(DeviceInfo_by_device_id, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint16_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, dsuid_t *, uint8_t *, uint8_t *));
MAKE_MOCK4(DeviceState, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t *));
MAKE_MOCK4(DeviceStatisticsRequest_get, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceProperties_set_zone, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t));
MAKE_MOCK4(DeviceProperties_set_locked_flag, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceProperties_set_name, int(DsmApiHandle_t, dsuid_t, uint16_t, const uint8_t *));
MAKE_MOCK4(DeviceProperties_set_button_active_group, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceProperties_set_button_set_local_priority, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceProperties_set_button_set_no_coming_home_call, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceProperties_set_button_set_apartment, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceProperties_set_button_set_output_channel, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK9(DeviceButtonInfo_by_device, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *));
MAKE_MOCK4(DeviceBinaryInput_get_count, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t *));
MAKE_MOCK9(DeviceBinaryInput_get_by_index, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *));
MAKE_MOCK4(DeviceGroupMembershipModify_add, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceGroupMembershipModify_remove, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK3(TestTransmissionQuality_get, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK3(TestDevicePresence, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK4(DeviceActionRequest_action_call_scene, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceActionRequest_action_save_scene, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK3(DeviceActionRequest_action_undo_scene, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK3(DeviceActionRequest_action_blink, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK4(DeviceActionRequest_action_undo_scene_number, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceActionRequest_action_force_call_scene, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceActionRequest_action_set_outval, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK3(DeviceActionRequest_action_programming_mode_on, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK3(DeviceActionRequest_action_programming_mode_off, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK4(DeviceActionRequest_action_opc_inc, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceActionRequest_action_opc_dec, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceActionRequest_action_opc_stop, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceActionRequest_action_extra_command, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK5(DeviceConfig_get, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t));
MAKE_MOCK6(DeviceConfig_set, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t, uint8_t));
MAKE_MOCK3(DeviceConfig_trigger_readout, int(DsmApiHandle_t, dsuid_t, dsuid_t));
MAKE_MOCK4(DeviceOPCConfig_get_current, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK6(DeviceOPCConfig_set_current_and_apply, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t, uint16_t));
MAKE_MOCK6(DeviceOPCConfig_set_current, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t, uint16_t));
MAKE_MOCK5(DeviceOPCConfig_get_scene, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t));
MAKE_MOCK7(DeviceOPCConfig_set_scene, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t, uint8_t, uint16_t));
MAKE_MOCK4(DeviceOPCConfig_get_scene_config, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK5(DeviceOPCConfig_set_scene_config, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t));
MAKE_MOCK4(DeviceOPCConfig_get_dc_flags, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK5(DeviceOPCConfig_set_dc_flags, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint16_t));
MAKE_MOCK4(DeviceOPCTable_get_count, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t *));
MAKE_MOCK5(DeviceOPCTable_get_by_index, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t *));
MAKE_MOCK4(DeviceSensor_get_value, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceSensor_get_count, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t *));
MAKE_MOCK8(DeviceSensor_get_by_index, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t *, uint32_t *, uint8_t *, uint8_t *));
MAKE_MOCK4(DeviceSensor_get_value_extended, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK2(CircuitRemoveInactiveDevices, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK3(CircuitRemoveDevice_by_id, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK3(CircuitRemoveDevice_by_dsuid, int(DsmApiHandle_t, dsuid_t, dsuid_t));

MAKE_MOCK3(CircuitPingDevices_automatic, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK4(CircuitPingDevices_one_time_automatic, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t));
MAKE_MOCK3(CircuitPingDevices_one_time_off, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK2(CircuitPingDevices_off, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK3(CircuitPingDevices_automatic_s, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK4(CircuitPingDevices_one_time_automatic_s, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t));
MAKE_MOCK3(CircuitPingDevices_one_time_off_s, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK6(CircuitEnergyMeterValue_get, int(DsmApiHandle_t, dsuid_t, uint32_t *, uint32_t *, uint32_t *, uint32_t *));
MAKE_MOCK6(CircuitEnergyMeterValue_reset, int(DsmApiHandle_t, dsuid_t, uint32_t *, uint32_t *, uint32_t *, uint32_t *));
MAKE_MOCK7(CircuitEnergyMeterValue_calibration, int(DsmApiHandle_t, dsuid_t, uint16_t *, uint16_t *, uint16_t *, uint32_t *, uint32_t *));
MAKE_MOCK6(CircuitEnergyMeterValue_Ws_get,
           int(DsmApiHandle_t, dsuid_t, uint32_t *, uint32_t *, uint32_t *, uint32_t *));
MAKE_MOCK5(CircuitCurrentMeterValue_get, int(DsmApiHandle_t, dsuid_t, uint16_t *, uint16_t *, uint16_t *));
MAKE_MOCK3(CircuitPowerState_max_count, int(DsmApiHandle_t, dsuid_t, uint8_t *));
MAKE_MOCK7(CircuitPowerState_get, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t *, uint8_t *, uint32_t *, uint32_t *));
MAKE_MOCK5(CircuitPowerState_config, int(DsmApiHandle_t, dsuid_t, uint8_t, uint32_t, uint32_t));

MAKE_MOCK8(dSMInfo, int(DsmApiHandle_t, dsuid_t, uint32_t *, uint32_t *, uint32_t *, uint16_t *, dsid_t *, uint8_t *));
MAKE_MOCK3(dSMProperties_set_name, int(DsmApiHandle_t, dsuid_t, const uint8_t *));
MAKE_MOCK3(dSMProperties_set_apartment_id, int(DsmApiHandle_t, dsuid_t, uint8_t));
MAKE_MOCK4(dSMProperties_set_temperature_limits, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t));
MAKE_MOCK3(dSMProperties_get_apartment_id, int(DsmApiHandle_t, dsuid_t, uint8_t *));
MAKE_MOCK4(dSMProperties_get_temperature_limits, int(DsmApiHandle_t, dsuid_t, uint8_t *, uint8_t *));
MAKE_MOCK3(dSMProperties_get_current_temperature, int(DsmApiHandle_t, dsuid_t, uint16_t *));
MAKE_MOCK3(dSMProperties_set_flags, int(DsmApiHandle_t, dsuid_t, uint8_t));
MAKE_MOCK3(dSMProperties_get_flags, int(DsmApiHandle_t, dsuid_t, uint8_t *));
MAKE_MOCK3(dSMProperties_get_power_down_duration, int(DsmApiHandle_t, dsuid_t, uint8_t *));
MAKE_MOCK4(dSMProperties_set_ping_intervals, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t));
MAKE_MOCK4(dSMProperties_get_ping_intervals, int(DsmApiHandle_t, dsuid_t, uint16_t *, uint16_t *));
MAKE_MOCK3(dSMProperties_get_max_temperature, int(DsmApiHandle_t, dsuid_t, uint16_t *));
MAKE_MOCK2(dSMProperties_reset_max_temperature, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK3(dSMProperties_set_upstream_frequency, int(DsmApiHandle_t, dsuid_t, uint8_t));
MAKE_MOCK3(dSMProperties_get_upstream_frequency, int(DsmApiHandle_t, dsuid_t, uint8_t *));
MAKE_MOCK3(dSMProperties_get_apartment_state, int(DsmApiHandle_t, dsuid_t, uint8_t *));
MAKE_MOCK4(dSMProperties_set_ping_intervals_s, int(DsmApiHandle_t, dsuid_t, uint16_t, uint16_t));
MAKE_MOCK4(dSMProperties_get_ping_intervals_s, int(DsmApiHandle_t, dsuid_t, uint16_t *, uint16_t *));
MAKE_MOCK8(dSMState, int(DsmApiHandle_t, dsuid_t, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *));
MAKE_MOCK4(dSMConfig_set_dSM_config, int(DsmApiHandle_t, dsuid_t, dsid_t, uint32_t));
MAKE_MOCK4(dSMConfig_get_DSP_config, int(DsmApiHandle_t, dsuid_t, uint8_t *, uint8_t *));
MAKE_MOCK4(dSMConfig_set_DSP_config, int(DsmApiHandle_t, dsuid_t, uint8_t, const uint8_t *));
MAKE_MOCK5(dSMConfig_get_hash, int(DsmApiHandle_t, dsuid_t, uint32_t *, uint32_t *, uint32_t *));
MAKE_MOCK6(UserProtobufMessageRequest, int(DsmApiHandle_t, dsuid_t, uint16_t, const uint8_t *, uint16_t *, uint8_t *));

MAKE_MOCK2(dSMStatistics_reset_dS485, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK5(dSMStatistics_get_upstream, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t *, uint8_t *));
MAKE_MOCK2(dSMStatistics_reset_upstream, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK11(dSMStatistics_get_internals, int(DsmApiHandle_t, dsuid_t, uint32_t *, uint32_t *, uint32_t *, uint32_t *, uint32_t *, uint32_t *, uint32_t *, uint32_t *, uint32_t *));
MAKE_MOCK2(dSMStatistics_reset_internals, int(DsmApiHandle_t, dsuid_t));

MAKE_MOCK8(dSMStatistics_get_stop_timer, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint32_t *));
MAKE_MOCK2(dSMReboot, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK3(dSMFactoryReset, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK4(ImageMaintenance_check_image, int(DsmApiHandle_t, dsuid_t, uint16_t *, uint16_t *));
MAKE_MOCK7(ImageMaintenance_get_image_info, int(DsmApiHandle_t, dsuid_t, uint32_t *, uint32_t *, uint32_t *, uint32_t *, uint16_t *));
MAKE_MOCK2(ImageMaintenance_start_update, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK2(ImageMaintenance_remove_image, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK7(ImageTransfer_write_request, int(DsmApiHandle_t, dsuid_t, uint32_t, uint32_t, uint32_t, uint32_t, uint16_t));
MAKE_MOCK6(ImageTransfer_data, int(DsmApiHandle_t, dsuid_t, uint32_t, const uint8_t *, uint32_t *, uint32_t *));

MAKE_MOCK9(dSFInfo, int(DsmApiHandle_t, dsuid_t, uint32_t *, uint32_t *, uint32_t *, uint32_t *, uint16_t *, dsid_t *, uint8_t *));
MAKE_MOCK6(dSFStatistics_get_DSP, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t, uint8_t *, uint8_t *));
MAKE_MOCK3(dSFStatistics_reset_DSP, int(DsmApiHandle_t, dsuid_t, uint8_t));
MAKE_MOCK5(dSFStatistics_get_booster, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t *, uint8_t *));
MAKE_MOCK2(dSFStatistics_reset_booster, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK5(dSFStatistics_get_ARM, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t *, uint8_t *));
MAKE_MOCK2(dSFStatistics_reset_ARM, int(DsmApiHandle_t, dsuid_t));

MAKE_MOCK7(dSFStatistics_get_grid_quality, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t, uint8_t *, uint8_t *, uint8_t *));
MAKE_MOCK7(dSFStatistics_get_20k_band_fft, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t, uint16_t *, uint8_t *, uint8_t *));
MAKE_MOCK11(dSFState, int(DsmApiHandle_t, dsuid_t, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *, uint8_t *));
MAKE_MOCK5(dSFConfig_set_DSP_config, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t, const uint8_t *));
MAKE_MOCK5(dSFConfig_get_DSP_config, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t *, uint8_t *));
MAKE_MOCK4(dSFConfig_set_dSF_config, int(DsmApiHandle_t, dsuid_t, dsid_t, uint32_t));
MAKE_MOCK4(dSFConfig_set_booster_arm_config, int(DsmApiHandle_t, dsuid_t, uint8_t, const uint8_t *));
MAKE_MOCK4(dSFConfig_get_booster_arm_config, int(DsmApiHandle_t, dsuid_t, uint8_t *, uint8_t *));
MAKE_MOCK4(dSFFilter_start_probing, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t));
MAKE_MOCK8(dSFFilter_set_coeffs, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t, uint8_t, uint8_t, uint8_t, const uint8_t *));
MAKE_MOCK8(dSFFilter_get_coeffs, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t, uint8_t, uint8_t *, uint8_t *, uint8_t *));
MAKE_MOCK5(dSFFilter_unfreeze_filter, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t, uint8_t));
MAKE_MOCK3(dSFDebugMode_restart_dsp, int(DsmApiHandle_t, dsuid_t, uint8_t));
MAKE_MOCK2(dSFDebugMode_restart_booster_arm, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK4(dSFDebugMode_watchdog_state, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t));
MAKE_MOCK3(dSFDebugMode_erase_config, int(DsmApiHandle_t, dsuid_t, uint8_t));
MAKE_MOCK5(dSFDebugMode_generator_mode, int(DsmApiHandle_t, dsuid_t, uint8_t, uint16_t, uint32_t));
MAKE_MOCK6(dSFDebugMode_compensation_mode, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t, uint8_t, uint8_t));
MAKE_MOCK5(dSFBooster_set_booster_enable, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t, uint8_t));
MAKE_MOCK5(dSFBooster_get_booster_enable, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t *, uint8_t *));
MAKE_MOCK7(dSFBooster_set_window_timing, int(DsmApiHandle_t, dsuid_t, uint8_t, uint16_t, uint16_t, uint16_t, uint16_t));
MAKE_MOCK7(dSFBooster_get_window_timing, int(DsmApiHandle_t, dsuid_t, uint8_t, uint16_t *, uint16_t *, uint16_t *, uint16_t *));
MAKE_MOCK5(dSFBooster_set_min_max_period, int(DsmApiHandle_t, dsuid_t, uint8_t, uint16_t, uint16_t));
MAKE_MOCK3(dSFBooster_set_booster_event_threshold, int(DsmApiHandle_t, dsuid_t, uint16_t));
MAKE_MOCK3(dSFBooster_get_booster_event_threshold, int(DsmApiHandle_t, dsuid_t, uint16_t *));
MAKE_MOCK3(dSFProperties_get_current_temperature_top, int(DsmApiHandle_t, dsuid_t, uint16_t *));
MAKE_MOCK4(dSFProperties_set_temperature_limits_booster, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t));
MAKE_MOCK4(dSFProperties_get_temperature_limits_booster, int(DsmApiHandle_t, dsuid_t, uint8_t *, uint8_t *));
MAKE_MOCK3(dSFProperties_get_max_temperature_top, int(DsmApiHandle_t, dsuid_t, uint16_t *));
MAKE_MOCK2(dSFProperties_reset_max_temperature_top, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK3(dSFProperties_get_current_temperature_bottom, int(DsmApiHandle_t, dsuid_t, uint16_t *));
MAKE_MOCK3(dSFProperties_get_max_temperature_bottom, int(DsmApiHandle_t, dsuid_t, uint16_t *));
MAKE_MOCK2(dSFProperties_reset_max_temperature_bottom, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK4(dSFProperties_set_temperature_limits_device, int(DsmApiHandle_t, dsuid_t, uint8_t, uint8_t));
MAKE_MOCK4(dSFProperties_get_temperature_limits_device, int(DsmApiHandle_t, dsuid_t, uint8_t *, uint8_t *));
MAKE_MOCK5(dSFImageMaintenance_check_image, int(DsmApiHandle_t, dsuid_t, uint32_t, uint16_t *, uint16_t *));
MAKE_MOCK3(dSFImageMaintenance_remove_image, int(DsmApiHandle_t, dsuid_t, uint32_t));
MAKE_MOCK3(dSFImageMaintenance_start_update, int(DsmApiHandle_t, dsuid_t, uint32_t));
MAKE_MOCK8(dSFImageMaintenance_get_image_info, int(DsmApiHandle_t, dsuid_t, uint32_t, uint32_t *, uint32_t *, uint32_t *, uint32_t *, uint32_t *));

MAKE_MOCK3(RemoveVdc, int(DsmApiHandle_t, dsuid_t, dsuid_t));

MAKE_MOCK5(ZoneGroupDslinkSend_not_last_byte_no_answer, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t));
MAKE_MOCK5(ZoneGroupDslinkSend_last_byte_no_answer, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t));
MAKE_MOCK4(DeviceDslinkSend_not_last_byte_no_answer, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceDslinkSend_last_byte_no_answer, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceDslinkSend_not_last_byte_with_answer, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));
MAKE_MOCK4(DeviceDslinkSend_last_byte_with_answer, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t));

MAKE_MOCK3(BusMember_get_type, int(DsmApiHandle_t, dsuid_t, uint8_t *));

MAKE_MOCK3(dSMDebugMode_set_MMI_flag, int(DsmApiHandle_t, dsuid_t, uint8_t));
MAKE_MOCK3(dSMDebugMode_get_MMI_flag, int(DsmApiHandle_t, dsuid_t, uint8_t *));
MAKE_MOCK2(dSMDebugMode_stop_select_b, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK2(dSMDebugMode_restart_registration, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK2(dSMDebugMode_restart_dsp, int(DsmApiHandle_t, dsuid_t));
MAKE_MOCK4(dSMDebugMode_read_flash, int(DsmApiHandle_t, dsuid_t, uint32_t, uint8_t *));
MAKE_MOCK4(dSMDebugMode_write_flash, int(DsmApiHandle_t, dsuid_t, uint32_t, const uint8_t *));
MAKE_MOCK3(dSMDebugMode_get_communication_log_state, int(DsmApiHandle_t, dsuid_t, uint8_t *));
MAKE_MOCK3(dSMDebugMode_set_communication_log_state, int(DsmApiHandle_t, dsuid_t, uint8_t));
MAKE_MOCK3(dSMDebugMode_disable_jumble, int(DsmApiHandle_t, dsuid_t, uint8_t));
MAKE_MOCK10(dSMDebugMode_inject_short_upstream, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t, uint8_t, uint8_t, uint8_t, uint8_t, uint8_t));
MAKE_MOCK9(dSMDebugMode_inject_long_upstream, int(DsmApiHandle_t, dsuid_t, uint16_t, uint8_t, uint8_t, uint8_t, uint32_t, uint8_t, uint8_t));


};

extern DsmApi dsm_api_mock;
