/*
    Copyright (c) 2019 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation," " either version 3 of the License," " or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful," "
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not," " see <http://www.gnu.org/licenses/>.
*/

#include "event.h"

#include <ds/catch/catch.h>
#include <ds/log.h>

static ds::LogChannel dsLogChannel("eventTest");
static const char* TAGS = "[event]";

using namespace dss;
using namespace std::literals;
using namespace trompeloeil;
using trompeloeil::_;

namespace {

TEST_CASE("Event Struct", TAGS) {
  SECTION("CallOrigin") {
    Event event("testEvent");
    THEN("CallOrigin undefined") { CHECK(event.getPropertyByName<CallOrigin>("param"s) == CallOrigin::unknown); }
    WHEN("valid CallOrigin set") {
      event.setProperty("param"s, CallOrigin::system);
      CHECK(event.getPropertyByName<CallOrigin>("param"s) == CallOrigin::system);
    }
    WHEN("out-of-range CallOrigin set") {
      event.setProperty("param"s, static_cast<CallOrigin>(99));
      THEN("out-of-rnage CallOrigin returned") {
        CHECK(event.getPropertyByName<CallOrigin>("param"s) == static_cast<CallOrigin>(99));
      }
    }
  }
}
}
