/*
    Copyright (c) 2021 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

#include <trompeloeil.hpp>

#include "open-metering-system.h"
#include "readings/open-metering-system.h"

namespace dss::metering {

struct OpenMeteringSystemMock final : public trompeloeil::mock_interface<dss::metering::OpenMeteringSystem> {
  IMPLEMENT_CONST_MOCK0(activeMeterId);
  IMPLEMENT_MOCK1(setActiveMeterId);
  IMPLEMENT_CONST_MOCK0(meterings);
  IMPLEMENT_CONST_MOCK3(getLastReading);
  IMPLEMENT_CONST_MOCK6(getSeries);
  IMPLEMENT_MOCK1(addReading);
};

} // namespace dss::metering
