
#include "config-file.h"

#include <filesystem>

static ds::LogChannel dsLogChannel("dssMODBUSConfigFile");

namespace dss::modbus {

ConfigFile loadConfigFile(ds::System& system) {
  auto filePath = std::filesystem::path(system.dirs().sysconfdir) / "modbus-config.json";
  DS_NOTICE("Load configuration", filePath.string());
  auto file = system.readFileIfExists(filePath.string());
  if (!file) {
    DS_NOTICE("File not found. Load default configuration.");
    return ConfigFile{};
  }
  return ds::fromJson<ConfigFile>(*file);
}

} // namespace dss::modbus

DS_JSON_DEFINE_STRUCT((dss::modbus), ConfigFile);
DS_JSON_DEFINE_STRUCT((dss::modbus), ModbusMiscConfig);
