
#pragma once

#include <trompeloeil.hpp>

#include "deviceinterface.h"

namespace dss {

class IDeviceInterfaceMock : public trompeloeil::mock_interface<IDeviceInterface> {
  IMPLEMENT_MOCK2(turnOn);
  IMPLEMENT_MOCK2(turnOff);

  IMPLEMENT_MOCK2(increaseValue);
  IMPLEMENT_MOCK2(decreaseValue);

  IMPLEMENT_MOCK4(setValue);
  IMPLEMENT_MOCK5(callScene);
  IMPLEMENT_MOCK4(callSceneMin);
  IMPLEMENT_MOCK3(saveScene);
  IMPLEMENT_MOCK4(undoScene);
  IMPLEMENT_MOCK3(undoSceneLast);

  IMPLEMENT_MOCK0(getPowerConsumption);

  IMPLEMENT_MOCK2(nextScene);
  IMPLEMENT_MOCK2(previousScene);
  IMPLEMENT_MOCK3(blink);
  IMPLEMENT_MOCK4(increaseOutputChannelValue);

  IMPLEMENT_MOCK4(decreaseOutputChannelValue);
  IMPLEMENT_MOCK4(stopOutputChannelValue);

  IMPLEMENT_MOCK6(pushSensor);
};

} // namespace dss
