/*
    Copyright (c) 2013 digitalSTROM.org, Zurich, Switzerland

    Author: Christian Hitz, aizo AG <christian.hitz@aizo.com>

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#pragma once

#include <string>

#include "dssfwd.h"
#include "exception.h"
#include "model/addressablemodelitem.h"
#include "model/deviceinterface.h"

namespace dss {

class SceneAccess {
public:
  static bool checkAccess(const Apartment& apartment, const AddressableModelItem* _pTarget,
                          const SceneAccessCategory _category);
  static bool checkStates(const Apartment& apartment, const AddressableModelItem* _pTarget, const int _sceneNr);
  static SceneAccessCategory stringToCategory(const std::string& _categoryString);
};

class SceneAccessException : public DSSException {
public:
  SceneAccessException(const std::string& _message) : DSSException(_message) {}
}; // SceneAccessException

} // namespace dss
