// Generated by Cap'n Proto compiler, DO NOT EDIT
// source: device-config.capnp

#pragma once

#include <array>
#include <string>
#include <vector>
#include <cstdint>
#include <iosfwd>
#include <utility>
#include <ds/enum.h>

extern "C" {
typedef struct json_object json_object;
}
namespace dss {
class JSONWriter;
}


namespace dss {
namespace view {
namespace deviceConfig {
namespace dssCapnp {

enum class Application : uint16_t {
  NONE,
  LIGHTS,
  BLINDS,
  HEATING,
  AUDIO,
  VIDEO,
  JOKER,
  COOLING,
  VENTILATION,
  WINDOW,
  RECIRCULATION,
  TEMPERATURE_CONTROL,
  APARTMENT_VENTILATION,
  APARTMENT_RECIRCULATION,
  SECURITY,
  ACCESS,
  AWNINGS,
};
struct Cluster;
enum class Args_InputTypeMode : uint16_t {
  HIDDEN_PUSH_BUTTON,
  SHOWN_PUSH_BUTTON_AND_SENSOR,
};
struct Args;
enum class Value_InputType : uint16_t {
  PUSH_BUTTON,
  STATE,
};
enum class Value_Application : uint16_t {
  LIGHTS,
  BLINDS,
  HEATING,
  AUDIO,
  VIDEO,
  JOKER,
  RECIRCULATION,
  SECURITY,
  ACCESS,
  WINDOW,
  APARTMENT_VENTILATION,
  TEMPERATURE_CONTROL,
  VENTILATION,
  AWNINGS,
};
enum class Value_PushButtonTarget : uint16_t {
  DEVICE,
  ZONE,
  AREA,
  CLUSTER,
  APP,
  ALARM,
  PANIC,
  LEAVING_HOME,
  DOOR_BELL,
  DISABLED,
};
enum class Value_PushButtonTargetArea : uint16_t {
  AREA1,
  AREA2,
  AREA3,
  AREA4,
};
enum class Value_PushButtonTargetPresets : uint16_t {
  DEVICE_PRESETS2_TO4,
  ZONE_PRESETS1_TO4,
  ZONE_PRESETS10_TO14,
  ZONE_PRESETS20_TO24,
  ZONE_PRESETS30_TO34,
  ZONE_PRESETS40_TO44,
  AREA1_PRESETS1_TO4,
  AREA2_PRESETS1_TO4,
  AREA3_PRESETS1_TO4,
  AREA4_PRESETS1_TO4,
  AREA1_PRESETS12_TO14,
  AREA2_PRESETS22_TO24,
  AREA3_PRESETS32_TO34,
  AREA4_PRESETS42_TO44,
};
enum class Value_PushButtonMode : uint16_t {
  MODE1WAY,
  MODE2WAY_DOWN,
  MODE2WAY_UP,
};
enum class Value_StateType : uint16_t {
  GENERIC,
  PRESENCE,
  TWILIGHT,
  MOTION,
  SMOKE,
  WIND_STRENGTH_ABOVE_LIMIT,
  RAIN,
  SUN_RADIATION,
  SUN_PROTECTION,
  FROST,
  TEMPERATURE_BELOW_LIMIT,
  WINDOW_IS_OPEN,
  DOOR_IS_OPEN,
  GARAGE_DOOR_IS_OPEN,
  HEATING_SYSTEM_ENABLED,
  CHANGE_OVER_SIGNAL,
  MALFUNCTION,
  SERVICE,
};
enum class Value_StateTarget : uint16_t {
  WHOLE_APARTMENT,
  APARTMENT_VENTILATION,
  VENTILATION,
  RECIRCULATION,
};
enum class Value_StateMode : uint16_t {
  STANDARD,
  INVERTED,
  RISING_EDGE1,
  FALLING_EDGE1,
  RISING_EDGE0,
  FALLING_EDGE0,
  TOGGLE_MODE_ON_RISING_EDGE,
  TOGGLE_MODE_ON_FALLING_EDGE,
};
struct Value;
struct Data;

// =======================================================================================

ds::Enum<Application> dsEnum(Application) __attribute__((const));
std::ostream& operator<<(std::ostream&, Application);

struct Cluster {

   ::uint32_t id;
   ::dss::view::deviceConfig::dssCapnp::Application application;
   ::std::string title;

  Cluster();

  void addFieldsToJson(::dss::JSONWriter&) const;
  void setJson(::json_object*);
  static Cluster fromJson(const char*);
};
std::ostream& operator<<(std::ostream&, const Cluster&);

ds::Enum<Args_InputTypeMode> dsEnum(Args_InputTypeMode) __attribute__((const));
std::ostream& operator<<(std::ostream&, Args_InputTypeMode);

struct Args {
  typedef Args_InputTypeMode InputTypeMode;

   ::std::vector< ::dss::view::deviceConfig::dssCapnp::Cluster> memberOfClusters;
  bool showApplication;
  bool showTemperatureControlApplication;
  bool showApartmentApplications;
  bool showInput;
   ::dss::view::deviceConfig::dssCapnp::Args::InputTypeMode inputTypeMode;
  bool showPushButtonApplication;
  bool showPushButtonDeviceMode;
  bool showPushButtonDisabledMode;
  bool showPushButtonMode;
  bool showOutput;
  bool showOutputAttachedDevice;

  Args();

  void addFieldsToJson(::dss::JSONWriter&) const;
  void setJson(::json_object*);
  static Args fromJson(const char*);
};
std::ostream& operator<<(std::ostream&, const Args&);

ds::Enum<Value_InputType> dsEnum(Value_InputType) __attribute__((const));
std::ostream& operator<<(std::ostream&, Value_InputType);

ds::Enum<Value_Application> dsEnum(Value_Application) __attribute__((const));
std::ostream& operator<<(std::ostream&, Value_Application);

ds::Enum<Value_PushButtonTarget> dsEnum(Value_PushButtonTarget) __attribute__((const));
std::ostream& operator<<(std::ostream&, Value_PushButtonTarget);

ds::Enum<Value_PushButtonTargetArea> dsEnum(Value_PushButtonTargetArea) __attribute__((const));
std::ostream& operator<<(std::ostream&, Value_PushButtonTargetArea);

ds::Enum<Value_PushButtonTargetPresets> dsEnum(Value_PushButtonTargetPresets) __attribute__((const));
std::ostream& operator<<(std::ostream&, Value_PushButtonTargetPresets);

ds::Enum<Value_PushButtonMode> dsEnum(Value_PushButtonMode) __attribute__((const));
std::ostream& operator<<(std::ostream&, Value_PushButtonMode);

ds::Enum<Value_StateType> dsEnum(Value_StateType) __attribute__((const));
std::ostream& operator<<(std::ostream&, Value_StateType);

ds::Enum<Value_StateTarget> dsEnum(Value_StateTarget) __attribute__((const));
std::ostream& operator<<(std::ostream&, Value_StateTarget);

ds::Enum<Value_StateMode> dsEnum(Value_StateMode) __attribute__((const));
std::ostream& operator<<(std::ostream&, Value_StateMode);

struct Value {
  typedef Value_InputType InputType;
  typedef Value_Application Application;
  typedef Value_PushButtonTarget PushButtonTarget;
  typedef Value_PushButtonTargetArea PushButtonTargetArea;
  typedef Value_PushButtonTargetPresets PushButtonTargetPresets;
  typedef Value_PushButtonMode PushButtonMode;
  typedef Value_StateType StateType;
  typedef Value_StateTarget StateTarget;
  typedef Value_StateMode StateMode;

   ::dss::view::deviceConfig::dssCapnp::Value::InputType inputType;
   ::dss::view::deviceConfig::dssCapnp::Value::Application application;
   ::dss::view::deviceConfig::dssCapnp::Value::PushButtonTarget pushButtonTarget;
   ::dss::view::deviceConfig::dssCapnp::Value::PushButtonTargetArea pushButtonTargetArea;
   ::uint32_t pushButtonTargetClusterId;
   ::dss::view::deviceConfig::dssCapnp::Value::PushButtonTargetPresets pushButtonTargetPresets;
  bool pushButtonLocalPriorityFor1xClick;
  bool pushButtonCallsPresent;
   ::dss::view::deviceConfig::dssCapnp::Value::PushButtonMode pushButtonMode;
   ::dss::view::deviceConfig::dssCapnp::Value::StateType stateType;
   ::dss::view::deviceConfig::dssCapnp::Value::StateTarget stateTarget;
   ::dss::view::deviceConfig::dssCapnp::Value::StateMode stateMode;

  Value();

  void addFieldsToJson(::dss::JSONWriter&) const;
  void setJson(::json_object*);
  static Value fromJson(const char*);
};
std::ostream& operator<<(std::ostream&, const Value&);

struct Data {

   ::dss::view::deviceConfig::dssCapnp::Args args;
   ::dss::view::deviceConfig::dssCapnp::Value value;

  Data();

  void addFieldsToJson(::dss::JSONWriter&) const;
  void setJson(::json_object*);
  static Data fromJson(const char*);
};
std::ostream& operator<<(std::ostream&, const Data&);

// =======================================================================================

inline Cluster::Cluster() 
  : id()
  , application()
{}

inline Args::Args() 
  : showApplication()
  , showTemperatureControlApplication()
  , showApartmentApplications()
  , showInput()
  , inputTypeMode()
  , showPushButtonApplication()
  , showPushButtonDeviceMode()
  , showPushButtonDisabledMode()
  , showPushButtonMode()
  , showOutput()
  , showOutputAttachedDevice()
{}

inline Value::Value() 
  : inputType()
  , application()
  , pushButtonTarget()
  , pushButtonTargetArea()
  , pushButtonTargetClusterId()
  , pushButtonTargetPresets()
  , pushButtonLocalPriorityFor1xClick()
  , pushButtonCallsPresent(true)
  , pushButtonMode()
  , stateType()
  , stateTarget()
  , stateMode()
{}

inline Data::Data() 
{}

}  // namespace
}  // namespace
}  // namespace
}  // namespace

